(* DWIN.PAS: Please read the bottom of this program for Copyright details. *)

Program DWinRun;
{M 32768, 0, 81920}
{$M $8000, 0, $14000}
{M 16384, 0, 327680}
{M 65520, 0, 655360}
{65536, 32768, 16384, 8192}
{$F+}{$B+}

{$I Defines.src}

uses dos, graph, strings, dconst, cgmouse
  {$ifdef Graph2}, graph2{$Endif};

var A1C1: procedure;
 stuipdDS: word;
{$I dproto.pas}

var Vw: dwin;

var v, oldcm, level, l, u, vlev, page,
    btto:                                byte;
    MenY1, MenY2, MenX1, MenX2, skip,
    mousex, mousey, mousex1, mousey1:    word;
    menuExist, kbbusy, mBusy, Com2,
    kbrun, mrun:                         boolean;
    Mother, Dummy, Father, Last:         PMenu;
    winMom, winDad, winDummy, winDum,
    winMenNum:                           PWins;
    menuHst:                             PHots;
    rege:                                registers;
    return, sil:                         skel;
    copyPath:                            string;
    old09, old0c, test0c:                procedure;
var MenuHot: array[0..5] of record
     xPos, yPos, x1Pos, y1Pos: integer;
    end;
    momMenu: array[1..5,0..20] of Record
     PMen: PMenu;
     menuX, menuY: integer;
    end;
    MouseQue: array[0..1] of Record
     mX, mY: integer;
     button: integer;
     active: boolean;
    end;
    winSort: array[0..1000] of pointer;
    OrgX, OrgY: array[0..5] of integer;
    OrgMom: array[0..5] of PMenu;

function dexec(cmd,args: string):word; forward;

{L 1.obj}
{procedure teem(x, y, h, w: integer; msg: string; cmd: word; winDu: PWins; extra: string); forward;
var _teem: pointer;
{ begin
  asm
  mov sp, bp;
  pop bp;
  mov ax, $0E
  jmp draw.buttn;
  end;
end;}


{I dwinbrow.pas}
{$I dwindesk.pas}
{$I dwindraw.pas}
{$I dwinhots.pas}
{$I dwinmain.pas}
{$I dwinmenu.pas}
{$I dwinskin.pas}
{$I dwinwins.pas}
{$ifdef SAP}{$I dwinsap.pas}{$endif}

procedure A09; interrupt;
var getreg: registers;
begin
 inline ($9C);
 Old09;
 if kbBusy = False then
 begin
  getreg.ah:= $11;
  intr($16,  getreg);
  if (getreg.flags AND fzero) <> fzero then
  begin
   kbBusy := TRUE;
   getreg.ax := $1000;
   intr($16, getreg);
   mbusy := true;
   Vw.handlekey(getreg.ax);
   mbusy := false;
   kbBusy := False;
  end;
 end;
end;

procedure A0C; interrupt;
begin
 inline ($9C);
 Old0C;
 if mBusy = false then
 begin
  Vw.domouse(mousex1, mousey1, false);
  Vw.domouse(mousex, mousey, true);
  mousex1 := mousex; mousey1 := mousey;
  mousex := GetMouseX; mousey := GetMouseY;
 end;
 if mrun = false then
 begin
 if ((button = 0) AND (btto <> 0)) then
 begin
  if mouseX >= GetMaxX then v:=1;
  mbusy := true; mrun :=  true;
  MouseQue[1].mX := mouseX; MouseQue[1].mY := mouseY;
  MouseQue[1].button := btto; MouseQue[1].active := True;
  Vw.domouse(mousex1, mousey1, false);
  Vw.mouseEvent(MouseQue[1].mX, MouseQue[1].mY, MouseQue[1].button);
  Vw.domouse(mousex, mousey, true);
  repeat until button = 0;
  btto :=  0;
  mbusy := false; mrun :=  false;
 end else
 if button <> 0 then
  btto := button;
 end;
end;

function dexec(cmd, args: string): word;
var chCmd, charg: pchar;
 i: byte;
begin
 getMem(chcmd, length(cmd)+3);
 getMem(charg, length(args)+3);
 strPCopy(chcmd, cmd);
 strPCopy(charg, args);
 i := length(cmd);
 chCmd[i+0] := '$';
 chCmd[i+1] := #0;
 i := length(args);
 chArg[i+0] := '$';
 chArg[i+1] := #0;
 regs.ax := $0100;
 regs.dx := ofs(chCmd^);
 regs.ds := seg(chCmd^);
 regs.bx := ofs(chArg^);
 regs.es := seg(chArg^);
 intr($A8,regs);
 dexec := regs.ax;
 freemem(chcmd, length(cmd)+3);
 freemem(charg, length(args)+3);
end;

{procedure teem(x, y, h, w: integer; msg: string; cmd: word; winDu: PWins; extra: string); external;}

begin
kbBusy := true;
if ((paramstr(1) = '-h') OR (paramstr(1) = '/?') OR (paramstr(1) = '--help')) then
begin
 writeln('');
 writeln('(* ************************************************************ *)');
 writeln('(* Copyright (c) 1999-2000 Jon Gentle, All right reserved.      *)');
 writeln('(* ************************************************************ *)');
 writeln('(* This software is given As-Is.  No warranties of any kind,    *)');
 writeln('(* implied or expressed, are given to anyone.  The author(s)    *)');
 writeln('(* shall not be held for any liability under any circumstances. *)');
 writeln('(* Permission is granted to anyone who wishes to alter, use or  *)');
 writeln('(* distribute this software, as long as the following           *)');
 writeln('(* restrictions are met:                                        *)');
 writeln('(*                                                              *)');
 writeln('(* 1) The above copyright and this notice must appear in the    *)');
 writeln('(* software, both in binary and source code form.  Under no     *)');
 writeln('(* circumstance are these to be removed.                        *)');
 writeln('(* 2) Anyone other then the copyright owner that alters source  *)');
 writeln('(* code must mark the source code as altered.                   *)');
 writeln('(* 3) Original authorship of part or whole must not be          *)');
 writeln('(* misrepresented.                                              *)');
 writeln('(* ************************************************************ *)');
 halt(0);
end;
 {SapInit}
 {$ifdef SAP}sapInit;{$endif}
 {SapInit}
{ keep(0);
{ exec('c:\drdos\mem.exe','');
 readln;}
 {DeskInit}
 new(winMom);
 winmom^.init;
 winDad := winMom;
 {DeskInit}
 {MenuInit}
 Mother := VMenu.StdMenu;
 Dummy := Mother;
 skip := 1;
 {MenuInit}

{ _teem := @draw.buttn;}

 if Vw.Init = false then Halt(2);

 {MouseInit}
 mousex := GetMouseX; mousey := GetMouseY;
 mousex1 := mousex; mousey1 := mousey;
 Vw.domouse(mousex, mousey, true);
 mrun := false;
 {MouseInit}

 stuipdDS := seg(stuipdDS);

 {BrowInit?}
{ exec('.\brow.exe', '');}
 {BrowInit?}

 {InterruptInit}
{$ifndef debug}
 GetIntVec($09,@Old09);
 SetIntVec($09,Addr(A09));
{$endif}
 GetIntVec($0C,@Old0C);
 SetIntVec($0C,Addr(A0C)); com2 := false;
 {InterruptInit}
 kbBusy := False;
 mBusy := False;
 Vw.run;
 Vw.done;
end.

(* ************************************************************ *)
(* Copyright (c) 1999-2000 Jon Gentle, All right reserved.      *)
(* ************************************************************ *)
(* This software is given As-Is.  No warranties of any kind,    *)
(* implied or expressed, are given to anyone.  The author(s)    *)
(* shall not be held for any liability under any circumstances. *)
(* Permission is granted to anyone who wishes to alter, use or  *)
(* distribute this software, as long as the following           *)
(* restrictions are met:                                        *)
(*                                                              *)
(* 1) The above copyright and this notice must appear in the    *)
(* software, both in binary and source code form.  Under no     *)
(* circumstance are these to be removed.                        *)
(* 2) Anyone other then the copyright owner that alters source  *)
(* code must mark the source code as altered.                   *)
(* 3) Original authorship of part or whole must not be          *)
(* misrepresented.                                              *)
(* ************************************************************ *)