(* DWINSKIN.PAS: Please read the bottom of DWIN.PAS for Copyright details. *)

{procedure Skin.saveSkin;
var skinfile: file;
kisp: byte;
kisl: pointer;
begin
 loadskin;
end;}

procedure Skin.loadskin;
var skinfile, poinfile: file;
kisp: byte;
kisl: pointer;
dumbSkelo, prevSkelo:  ^skelo;
dumbImmg, prevImmg: ^immg;
kilp: word;
 return, sil:  skel;
begin
 assign(skinfile, 'defunk.skn');
 filemode := 2;
 reset(skinfile, 1);

 blockread(skinfile, VSkin.leftSpace, 1);
 blockread(skinfile, VSkin.rightSpace, 1);
 blockread(skinfile, VSkin.topSpace, 1);
 blockread(skinfile, VSkin.bottemSpace, 1);
 blockread(skinfile, VSkin.bgcolor, 1);

 new(prevImmg);
 VSkin.immgMom := @prevImmg^;
 kisp := 0;
 while kisp = 0 do
 begin
  new(dumbImmg);
  blockread(skinfile, dumbImmg^, 9);
  getMem(dumbImmg^.immgi, dumbImmg^.immgSize);
  blockread(skinfile, dumbImmg^.immgi^, dumbImmg^.immgSize);

  prevImmg^.nextImmg := dumbImmg;
  prevImmg := dumbImmg;
  prevImmg^.nextImmg := nil;
  if dumbImmg^.immgSize = 0 then kisp := 1;
 end;

 blockread(skinfile, VSkin.bttnspace.x, 1);
 blockread(skinfile, VSkin.bttnspace.y, 1);
 blockread(skinfile, VSkin.bttnspace.w, 1);
 blockread(skinfile, VSkin.bttnspace.h, 1);
 blockread(skinfile, VSkin.bttnbg, 1);
 new(prevImmg);
 VSkin.bttnMom := @prevImmg^;
 kisp := 0;
 while kisp = 0 do
 begin
  new(dumbImmg);
  blockread(skinfile, dumbImmg^, 9);
  getMem(dumbImmg^.immgi, dumbImmg^.immgSize);
  blockread(skinfile, dumbImmg^.immgi^, dumbImmg^.immgSize);

  prevImmg^.nextImmg := dumbImmg;
  prevImmg := dumbImmg;
  prevImmg^.nextImmg := nil;
  if dumbImmg^.immgSize = 0 then kisp := 1;
 end;

 blockread(skinfile, kisp, 4);
 blockread(skinfile, kisp, 1);
 getMem(VSkin.pointe, kisp);
 getMem(VSkin.pointeu, kisp);
 blockread(skinfile, VSkin.pointe^, kisp);

 new(prevSkelo);
 VSkin.skeloMom := @prevSkelo^;
 kilp  := 11;
 while kilp = 11  do
 begin
  new(dumbSkelo);
  blockread(skinfile, dumbSkelo^, 11, kilp);
  if kilp = 11 then
  begin
   getMem(dumbSkelo^.img, dumbSkelo^.imgSize);
   blockread(skinfile, dumbSkelo^.img^, dumbSkelo^.imgSize);
   if dumbSkelo^.imgSize < 5 then
   begin
    freeMem(dumbSkelo^.img, dumbSkelo^.imgSize);
    dumbSkelo^.img := nil;
   end;
   prevSkelo^.nextSkel := dumbSkelo;
   prevSkelo := dumbSkelo;
   prevSkelo^.nextSkel := nil;
  end;
 end;

 close(skinfile);

end;

procedure skin.makeIcons(selp: PWins; owne: string);
var tskin: skel;
 dumbSkel: ^skelo;
begin
 dumbSkel := VSkin.skeloMom^.nextSkel;
 while dumbSkel^.nextSkel <> nil do
 begin
  if dumbSkel^.x < 0  then tskin.x := selp^.priv.x+selp^.priv.w+dumbSkel^.x
   else tskin.x := selp^.priv.x+dumbSkel^.x;
  if dumbSkel^.y < 0  then tskin.y := selp^.priv.y+selp^.priv.h+dumbSkel^.y
   else tskin.y := selp^.priv.y+dumbSkel^.y;
  if dumbSkel^.w < 0 then tskin.w := selp^.priv.x+selp^.priv.w+dumbSkel^.w
   else tskin.w := tskin.x+dumbSkel^.w;
  if dumbSkel^.h < 0 then tskin.h := selp^.priv.y+selp^.priv.h+dumbSkel^.h
   else tskin.h := tskin.y+dumbSkel^.h;
  if ((selp^.minimized = true) AND (dumbSkel^.cmmd = winResize)) then break;
  if dumbSkel^.img <>  nil then putimage(tskin.x, tskin.y, dumbSkel^.img^, normalput);
  VHots.quilifyHotSpot(tskin.x, tskin.y, tskin.w, tskin.h, dumbSkel^.cmmd, owne, selp);
  dumbSkel := dumbSkel^.nextSkel;
 end;
end;

procedure skin.drawskin(sil: skel);
var dumbSkelo, prevSkelo:  ^skelo;
    dumbImmg, prevImmg: ^immg;
    i, a: word;
    tskin: skel;
begin
 return.x := sil.x - leftspace;
 return.y := sil.y - topspace;
 return.w := sil.w + rightspace+leftspace;
 return.h := sil.h + bottemspace+topspace;
{ return.w := sil.w + leftspace;
 return.h := sil.h + topspace;}
 sil := return;
 dumbImmg := @VSkin.immgMom^.nextImmg^;
 setcolor(bgcolor);
 VDraw.box(sil.x, sil.y, sil.x+sil.w, sil.y+sil.h);
{ sil.w := sil.w - leftspace;
 sil.h := sil.h - topspace;}
 setcolor(15);
 while dumbImmg^.nextImmg <> nil do
 begin
  if dumbImmg^.relX < 0 then tskin.x := sil.x+sil.w+dumbImmg^.relX-rightspace+2
   else tskin.x := sil.x+dumbImmg^.relX-1;
  if dumbImmg^.relY < 0 then tskin.y := sil.y+sil.h+dumbImmg^.relY-bottemspace+2
   else tskin.y := sil.y+dumbImmg^.relY-1;
  if dumbImmg^.relW < 0 then tskin.w := sil.x+sil.w+dumbImmg^.relW+1
   else if dumbImmg^.relW = 0 then tskin.w := tskin.x
   else tskin.w := dumbImmg^.relW+sil.x;
  if dumbImmg^.relH < 0 then tskin.h := sil.y+sil.h+dumbImmg^.relH+1
   else if dumbImmg^.relH = 0 then tskin.h := tskin.y
   else tskin.h := dumbImmg^.relH+sil.y;
  for i := tskin.x to tskin.w do
   for a := tskin.y to tskin.h do putimage(i, a, dumbImmg^.immgi^, normalput);  dumbImmg := dumbImmg^.nextImmg;
 end;
{ return.w := sil.w + leftspace;
 return.h := sil.h + topspace;}
end;

procedure skin.drawBttn(sil: skel);
var dumbSkelo, prevSkelo:  ^skelo;
    dumbImmg, prevImmg: ^immg;
    i, a: word;
    tskin: skel;
begin
 return.x := sil.x - bttnspace.x;
 return.y := sil.y - bttnspace.y;
 return.w := sil.w + bttnspace.x+bttnspace.w;
 return.h := sil.h + bttnspace.y+bttnspace.h;
 sil := return;
 dumbImmg := @VSkin.bttnMom^.nextImmg^;
 setcolor(bttnbg);
 VDraw.box(sil.x, sil.y, sil.x+sil.w, sil.y+sil.h);
 setcolor(15);
 while dumbImmg^.nextImmg <> nil do
 begin
  if dumbImmg^.relX < 0 then tskin.x := sil.x+sil.w+dumbImmg^.relX-bttnspace.w+2
   else tskin.x := sil.x+dumbImmg^.relX-1;
  if dumbImmg^.relY < 0 then tskin.y := sil.y+sil.h+dumbImmg^.relY-bttnspace.h+2
   else tskin.y := sil.y+dumbImmg^.relY-1;
  if dumbImmg^.relW < 0 then tskin.w := sil.x+sil.w+dumbImmg^.relW+1
   else if dumbImmg^.relW = 0 then tskin.w := tskin.x
   else tskin.w := dumbImmg^.relW+sil.x;
  if dumbImmg^.relH < 0 then tskin.h := sil.y+sil.h+dumbImmg^.relH+1
   else if dumbImmg^.relH = 0 then tskin.h := tskin.y
   else tskin.h := dumbImmg^.relH+sil.y;
  for i := tskin.x to tskin.w do
   for a := tskin.y to tskin.h do putimage(i, a, dumbImmg^.immgi^, normalput);
  dumbImmg := dumbImmg^.nextImmg;
 end;
end;
