(* DPROTO.PAS: Please read the bottom of DWIN.PAS or DLIB.PAS for Copyright details. *)

type
{ PBrow = ^brow;}
 PDesk = ^desk;
 PDraw = ^draw;
 PDwin = ^dwin;
 PHots = ^hots;
 PWins = ^Wins;
 PMenu = ^Menu;
 PSkin = ^Skin;

 skel = record
  x, y, w, h:  word;
 end;

{MAIN}

 dwin = object
  function init: boolean;
  procedure run;
  procedure handlekey(key: word);
  procedure domouse(Xpos, Ypos: word; OnOff: boolean);
  procedure mouseEvent(x,y: integer; btto: integer);
  procedure handleCommand(cmd: word; own: PWins; hst: PHots);
  procedure done;
 end;

{HOTS}

 hots = object{(dwin)}
   xTpos, yTpos, xBpos, yBpos: integer;
   command: word;
   ownerS: string;
   winNum: PWins;
   nextHot: PHots;
   icon: pointer;
   procedure quilifyHotSpot(x, y, x1, y1: integer; cmd: word;
      ownS: string; winNm: PWins);
   procedure requilifyHotSpot(x, y, x1, y1: integer; cmd: word; selp: PHots);
   procedure hotSpotDel(selp, prev: Phots);
 end;

{WINS}
 Wins = object{(dwin)}
  winImage: pointer;
  size: word;
  winImgX, winImgY: integer;
  winImgW, winImgH: integer;
  winMenu: PMenu;
  height: word;
  spotMom: PHots;
  nextWin: PWins;
  title: string;
  action: word;
  extra: byte;
  minimized: boolean;
  min, priv: skel;
  handleCmd, handleKey: procedure(incoming: word);
  procedure moveWin(own: PWins);
  procedure resizeWin(own: PWins);
  procedure minimize(own: PWins);
  procedure closeWin(this: PWins);
  procedure newWin(x, y, x1, y1: integer; s: string; dirshow: boolean);
  procedure makeIcon(x1, y1, x2, y2: integer; command: word;
    ownS: string; winNum: PWins);
  constructor init;
 end;

{Desk}
 Desk = object{(Wins)}
  procedure reload;
  function insert(x1, y1, x2, y2: integer; heigh: byte; menus: PMenu; s: string): PWins;
  procedure delete(dummy, prev: PWins);
  procedure repic(x1, y1, x2, y2: integer; oldPic: PWins);
  procedure focus(focusii: PWins);
 end;

{DRAW}
Draw = Object{(dwin)}
 procedure swich;
 procedure drawAbout;
 procedure drawBox(x, y, x1, y1: integer);
 procedure say(x, y: integer; what: string; align: byte);
 procedure box(x, y, x1, y1: integer);
 procedure buttn(x, y, h, w: integer; msg: string; cmd: word; winDu: PWins; extra: string);
 procedure rebuttn(midx, midy, h, w: integer; cmd: word; winDu: PHots; msg: string);
 procedure drawHotSpots;
end;

{MENU}

 Menu = object{(wins)}
  NextItem: PMenu;
  Name: String;
  NStat: byte;
  cmd: word;
  hotKey: word;
  procedure Init(NameI: String; command: word; hotke: word; Lev: Byte; Next: PMenu); virtual;
  Function NewI(NameI: String; command: word; hotke: word; Lev: Byte; Next: PMenu): PMenu;
  procedure KillMenu;
  function MenuEval(x, y: integer; own: byte): word;
  function menuMom: Pointer;
  function StdMenu: PMenu;
  procedure showMenu(x, y: integer; mothr: PMenu; o: byte);
 end;

{BROW}

{brow = object{(dwin)}
{ procedure showDir(x, y, x1, y1: integer; dire: string; own: PWins);
 procedure killDir(own: PWins);
 procedure copyFile(fle: string; cpdr: string);
end;}

{SKIN}
skelo = record
 x, y, w, h: integer;
 cmmd: word;
 imgSize: byte;
 nextSkel: pointer;
 img: pointer;
end;
immg = record
 relX, relY, relW, relH: integer;
 immgSize: byte;
 nextImmg: pointer;
 immgi: pointer;
end;

 skin = object{(wins)}
  pointe: pointer;
  pointeu: pointer;
  leftSpace, rightSpace,
  topSpace, bottemSpace: integer;
  bttnSpace: skel;
  bgcolor: integer;
  bttnbg: integer;
  skeloMom: ^skelo;
  immgMom: ^immg;
  bttnMom: ^immg;
{  procedure saveSkin;}
  procedure loadskin;
  procedure makeIcons(selp: PWins; owne: string);
  procedure drawskin(sil: skel);
  procedure drawBttn(sil: skel);
 end;

var
{ VBrow : brow;}
 VDesk : desk;
 VDraw : draw;
 VDwin : dwin;
 VHots : hots;
 VWins : Wins;
 VMenu : Menu;
 VSkin : Skin;

procedure checkDS(swich: boolean); forward;

{procedure drawAbout; forward;}
