(* DWINMAIN.PAS: Please read the bottom of DWIN.PAS for Copyright details. *)

procedure dwin.domouse(Xpos, Ypos: word; OnOff: boolean);
begin
{$ifdef Graph2}
 if OnOff = False then putimage2(Xpos, Ypos-2, VSkin.pointeu, normalPut);
 if OnOff = True then
 begin
  getimage(Xpos, Ypos-2, XPos+6, Ypos+4-2, VSkin.pointeu^);
  putimage2(Xpos, Ypos-2, VSkin.pointe, orPut);
 end;
{$Else}
 if OnOff = False then putimage(Xpos, Ypos-2, VSkin.pointeu^, normalPut);
 if OnOff = True then
 begin
  getimage(Xpos, Ypos-2, XPos+6, Ypos+4-2, VSkin.pointeu^);
  putimage(Xpos, Ypos-2, VSkin.pointe^, orPut);
 end;
{$Endif}
end;

Function dwin.init: boolean;
var F: File;
var i: word;
var x, y, x1, y1: word;
label donet, donef;
var
 grDriver, grmode, ErrCode: Integer;
 size: word;
begin
 initmouse;
 grDriver := 0;
 InitGraph(grDriver, grMode,' ');
 ErrCode := GraphResult;
 if ErrCode = grOk then
 begin
  init := true;
  mwindow(0, 2, GetMaxX, GetMaxY);
 end else
 begin
  writeln('WTIE handled a graphics problem');
  goto donef;
 end;

 goto donet;
 donef:
  init := false;
 donet:
 VSkin.loadskin;
 repic := false;
 VDraw.buttn(10, 288, 28, 10, 'DT!', winRun, winMom, 'd:\dwin\dterm\dterm.exe');
 VDraw.buttn(10, 305, 28, 10, 'A:\', winShell, winMom, 'A:\');
{ teem(10, 305, 28, 10, 'A:\', winDir, winMom, 'A:\');}
 VDraw.buttn(10, 322, 28, 10, 'B:\', winDir, winMom, 'B:\');
 VDraw.buttn(10, 339, 28, 10, 'C:\', winDir, winMom, 'C:\');
 VDraw.buttn(10, 356, 28, 10, 'D:\', winDir, winMom, 'D:\');
 VDraw.buttn(10, 373, 28, 10, 'E:\', winDir, winMom, 'E:\');
 VDraw.buttn(10, 390, 28, 10, 'DON', winEndSess, winMom, 'E:\');
 repic := true;
end;

procedure dwin.run;
var didl:string;
i:byte;
begin
 {Insert cleverly modified DServ code here}
 {DServ now defeats the purpose of having the debug
 code here.   El well}
 {Well, it seems as though the new keyboard layout
 lets the  keyboard work without a special debug
 function (sort  of)}
{ exec('dterm\dterm.exe','');}
 exec('dserv.com','');
 i := dosexitcode;
end;

procedure dwin.handlekey(key: word);
var i, o: integer;
    u: string;
    dumMenu: PMenu;
    dumWin: PWins;
begin
 dumWin := winMom;
 i := 0; o := 0;
 while ((dumWin <> nil) AND (o = 0)) do begin
  dumMenu := dumWin^.winMenu;
  while ((dumMenu <> nil) AND (o = 0)) do begin
   if key = dumMenu^.hotKey then
   begin
    handleCommand(dumMenu^.cmd, dumWin, dumWin^.spotMom);
    key := 0;  o := 1;
   end;
   dumMenu := dumMenu^.nextItem;
  end;
  dumwin := dumWin^.nextWin;
 end;
end;

procedure dwin.mouseEvent(x,y: integer; btto: integer);
var iop,  uop: byte;
 u : word;
 dummy: PWins;
 dumbhot: PHots;
begin
 u := 0; uop := 0;
 for iop := 5 downto 0 do
 begin
  if ((x >= MenuHot[iop].xpos)
  AND (x <= MenuHot[iop].x1Pos)
  AND (y <= MenuHot[iop].y1Pos)
  AND (y >= MenuHot[iop].ypos)) Then begin
   handleCommand(VMenu.MenuEval(x, y, iop), winMenNum, winMenNum^.spotMom);
   iop := 0; u := 1;
  end;
 end;

 dummy := winMom;
 if ((u = 0) AND (menuExist = TRUE)) then begin VMenu.killMenu; VDesk.reload; end;
 while ((dummy <> nil) AND (iop = 0) AND (u=0) AND (uop=0)) do begin
  VMenu.killMenu;
  dumbhot := dummy^.spotMom; iop := 0;
  while ((dumbhot <> nil) AND (iop = 0)) do
  begin
   if ((x >= dumbhot^.xTpos)
   AND (x <= dumbhot^.xBpos)
   AND (y <= dumbhot^.yBpos)
   AND (y >= dumbhot^.yTpos)
   AND ((dummy = winMom^.nextWin)
   OR (dummy = winMom))) Then
   begin
    if btto = 2 then handleCommand(winMenu, dummy, dumbHot);
    if btto = 1 then handleCommand(dumbhot^.command, dummy, dumbHot);
    iop := 1;
   end;
   dumbHot := dumbHot^.nextHot;
  end;
  if dummy = winMom^.nextWin then uop := 1 else dummy := dummy^.nextWin;
 end;
 dummy := dummy^.nextWin;
 while ((dummy <> nil) AND (iop = 0) AND (u=0)) do begin

   if ((x >= dummy^.priv.x)
   AND (x <= dummy^.priv.x + dummy^.priv.w)
   AND (y >= dummy^.priv.y)
   AND (y <= dummy^.priv.y + dummy^.priv.h)) Then
	begin
	 iop := 1;
    VDesk.focus(dummy);
   end
   else dummy := dummy^.nextWin;
 end;
end;

procedure dwin.handleCommand(cmd: word; own: PWins; hst: PHots);
var i: byte;
s: string;
t: string;
f: file;
begin
 case cmd of
  winMove: VWins.moveWin(own);
  winMenu: begin VMenu.showMenu(trunc((hst^.xBpos-hst^.xTpos)/2)+hst^.xTpos,
   trunc((hst^.yBpos-hst^.yTpos)/2)+hst^.yTpos,
	own^.winMenu, 1); winMenNum := own; menuHst := hst;
  end;
  winClose: VWins.closeWin(own);
  winNew: VWins.newWin(200, 150, 420, 270, 'Hello World', false);
  winReload: VDesk.reload;
  winAbout: VDraw.drawAbout;
  winEndSess: begin regs.ah :=$06; intr($A8, regs); end;{halt(0);{v := 1;{begin Vw.done; end;}
  winDir: VWins.newWin(200, 150, 420, 270, hst^.ownerS, true);
  winResize: own^.resizeWin(own);
  winMin: own^.minimize(own);
  winShowHot: VDraw.drawHotSpots;
  winCopy: copyPath := menuHst^.ownerS;
{  winPaste: VBrow.copyFile(copyPath, own^.title);}
  winDel:
  begin
   assign(f, menuHst^.ownerS);
   erase(f);
  end;
  winShell:	{exec('c:\command.com', '/T');} vdraw.drawAbout;
  winRun: dexec(hst^.ownerS, ''); { drawAbout;}
{  winSclDn:
  with own^ do if own^.action = winDir then
  begin
   extra := extra + trunc((winImgW)/104);
	VBrow.showDir(winImgX, winImgY, winImgX+winImgW, winImgY+winImgH, title, own);
  end;
  winSclUp:
  if own^.extra > 0 then with own^ do if own^.action = winDir then
  begin
   extra := extra - trunc((winImgW)/104);
  	VBrow.showDir(winImgX, winImgY, winImgX+winImgW, winImgY+winImgH, title, own);
  end;}
 else if addr(own^.handleCmd) <> nil then own^.handleCmd(cmd);
 end;
 i := dosexitcode;
 i := doserror;
end;

procedure dwin.done;
var  stdout: text;
begin
 closegraph;
{$ifndef debug}
 SetIntVec($09,Addr(Old09));
{$endif}
 if com2 = true then SetIntVec($0B,Addr(Old0C))
 else SetIntVec($0C,Addr(Old0C));
{ inline($9C);
 Old0C;}
{ halt(0);}
{ assign(stdout,  '');
 filemode:=2;
 rewrite(stdout);}
 writeln({stdout,} 'Thank you for using DWindows, the Windowed DOS enviroment.');
 writeln({stdout,} '-Jon Gentle (Creator of DWindows)');
end;
